<template>
  <q-page class="bg-grey-3">
    <q-toolbar class="bg-blue-10 text-white shadow-2">
      <q-toolbar-title class="q-ml-sm">Đơn hàng thành viên</q-toolbar-title>
    </q-toolbar>
    <mutate
      title="Đơn hàng thành viên"
      :columns="columns"
      :data="orders"
      :options="mutateOptions"
      @update="updateOrder"
      @table-request="options => getOrders({ options, userRetails: ['CONTRIBUTOR', 'CONTRIBUTOR_EDUCATED'] })"
    >
      <template slot="detail" slot-scope="props">
        <div class="detail-order">
          <div class="text-h6 q-mb-md">Xem chi tiết đơn hàng #{{props.detail.id}}</div>
          <fragment v-for="(item, key) in props.detail" :key="key">
            <div v-if="TABLE_DETAIL_TEXT[key]" class="row justify-between order-item">
              <div class="title">{{key | table-detail}}</div>
              <div v-if="item" class="text-right">
                <span v-if="key === 'createdAt'">{{item | moment}}</span>
                <span v-else-if="key === 'status'">{{item | order-status}}</span>
                <span v-else-if="key === 'orderDetails'">
                  <order-detail :order="props.detail" />
                </span>
                <span v-else-if="key === 'orderReceiver'">{{item.fullAddress}}</span>
                <span v-else>{{item}}</span>
              </div>
              <div v-else class="text-right text-italic">Không có dữ liệu</div>
            </div>
          </fragment>
        </div>
      </template>
      <template slot="mutation" slot-scope="props">
        <q-input v-model="props.data.shippingFee" outlined label="Phí vận chuyển" class="q-mb-md" />
      </template>
      <template slot="function" slot-scope="props">
        <q-btn
          v-if="props.row.status === 'PENDING'"
          flat
          dense
          icon="thumb_up"
          color="positive"
          class="q-mr-sm"
          @click="approveOrder(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Xác nhận đơn hàng</q-tooltip>
        </q-btn>
        <q-btn
          v-if="props.row.status === 'APPROVED'"
          flat
          dense
          icon="move_to_inbox"
          color="primary"
          class="q-mr-sm"
          @click="deliverOrder(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Giao đơn hàng</q-tooltip>
        </q-btn>
        <q-btn
          v-if="['DELIVERING', 'REJECTED'].indexOf(props.row.status) > -1"
          flat
          dense
          icon="done"
          color="positive"
          class="q-mr-sm"
          @click="completeOrder(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Hoàn thành đơn hàng</q-tooltip>
        </q-btn>
        <q-btn
          v-if="props.row.status !== 'REJECTED'"
          flat
          dense
          icon="close"
          color="negative"
          class="q-mr-sm"
          @click="rejectOrder(props.row.id)"
        >
          <q-tooltip anchor="top middle" self="bottom middle">Huỷ đơn hàng</q-tooltip>
        </q-btn>
      </template>
    </mutate>
  </q-page>
</template>

<script>
import moment from 'moment';
import { mapActions, mapState } from 'vuex';
import Mutate from '~/components/commons/Mutate.vue';
import OrderDetail from '~/components/commons/OrderDetail.vue';
import {
  TABLE_DETAIL_TEXT,
  ORDER_STATUS_TEXT,
  ORDER_STATUS
} from '~/commons/enums';

export default {
  components: { Mutate, OrderDetail },
  data() {
    return {
      TABLE_DETAIL_TEXT,
      columns: [
        {
          name: 'id',
          label: 'Mã đơn hàng',
          align: 'left',
          field: 'id',
          sortable: true
        },
        {
          name: 'user',
          label: 'Mã số TV',
          align: 'left',
          field: 'user',
          format: val => (val ? val.id : ''),
          sortable: true
        },
        {
          name: 'fullName',
          label: 'Tên người nhận',
          align: 'left',
          field: 'fullName',
          sortable: true
        },
        {
          name: 'phoneNumber',
          label: 'Số điện thoại',
          align: 'left',
          field: 'phoneNumber',
          sortable: true
        },
        {
          name: 'address',
          label: 'Địa chỉ giao hàng',
          align: 'left',
          field: 'orderReceiver',
          format: val => (val ? val.fullAddress : ''),
          sortable: true
        },
        {
          name: 'totalVat',
          label: 'Tổng tiền',
          align: 'left',
          field: 'totalVat',
          format: val => (val >= 0 ? `${val.toLocaleString()} VND` : ''),
          sortable: true
        },
        {
          name: 'totalBonusCommission',
          label: 'Tổng chiết khấu',
          align: 'left',
          field: 'totalBonusCommission',
          format: val => (val >= 0 ? `${val.toLocaleString()} VND` : ''),
          sortable: true
        },
        {
          name: 'totalEarning',
          label: 'Tổng TNCN',
          align: 'left',
          field: 'totalEarning',
          format: val => (val >= 0 ? `${val.toLocaleString()} VND` : ''),
          sortable: true
        },
        {
          name: 'shippingFee',
          label: 'Phí vận chuyển',
          align: 'left',
          field: 'shippingFee',
          format: val => (val > 0 ? `${val.toLocaleString()} VND` : 'Miễn phí'),
          sortable: true
        },
        {
          name: 'total',
          label: 'Tổng thanh toán',
          align: 'left',
          field: 'total',
          format: val => (val >= 0 ? `${val.toLocaleString()} VND` : ''),
          sortable: true
        },
        {
          name: 'note',
          label: 'Ghi chú',
          align: 'left',
          field: 'note',
          sortable: true
        },
        {
          name: 'status',
          label: 'Trạng thái',
          align: 'left',
          field: 'status',
          format: val => ORDER_STATUS_TEXT[val],
          sortable: true
        },
        {
          name: 'createdAt',
          label: 'Ngày tạo',
          align: 'left',
          field: 'createdAt',
          format: val => moment(val).format('DD/MM/YYYY HH:mm:ss'),
          sortable: true
        },
        {
          name: 'function',
          align: 'right'
        }
      ]
    };
  },
  computed: {
    ...mapState({
      orders: state => state.orders.orders,
      totalRows: state => state.orders.totalOrders,
      orderBrands: state => state.orderBrands.orderBrands,
      orderCategories: state => state.orderCategories.orderCategories
    }),
    mutateOptions() {
      return {
        totalRows: this.totalRows
      };
    }
  },
  mounted() {
    this.getOrders({ userRetails: ['CONTRIBUTOR', 'CONTRIBUTOR_EDUCATED'] });
  },
  methods: {
    ...mapActions({
      getOrders: 'orders/getOrders',
      updateOrder: 'orders/updateOrder'
    }),
    approveOrder(id) {
      this.updateOrder({ id, status: ORDER_STATUS.APPROVED });
    },
    deliverOrder(id) {
      this.updateOrder({ id, status: ORDER_STATUS.DELIVERING });
    },
    completeOrder(id) {
      this.updateOrder({ id, status: ORDER_STATUS.COMPLETED });
    },
    rejectOrder(id) {
      this.updateOrder({ id, status: ORDER_STATUS.REJECTED });
    }
  }
};
</script>

<style lang="scss" scoped>
.detail-order {
  .order-item {
    padding: 10px;

    &:nth-child(even) {
      background-color: rgba(0, 0, 0, 0.1);
    }

    .title {
      font-weight: bold;
    }
  }
}
.media-wrapper {
  display: flex;
  flex-direction: row;
  align-items: center;
  flex-wrap: wrap;

  .media-img {
    width: 50%;
    padding: 10px;

    img {
      width: 100%;
    }
  }
}
</style>
